Namespace My

    ' Les vnements suivants sont disponibles pour MyApplication:
    ' 
    ' Startup: dclench lors du dmarrage de l'application, avant la cration du formulaire de dmarrage.
    ' Shutdown: dclench aprs la fermeture de tous les formulaires de l'application. Cet vnement n'est pas dclench si l'application se termine de faon anormale.
    ' UnhandledException: dclench si l'application rencontre une exception non gre.
    ' StartupNextInstance: dclench lors du lancement d'une application  instance unique et si l'application est dj active. 
    ' NetworkAvailabilityChanged: dclench lorsque la connexion rseau est connecte ou dconnecte.
    Partial Friend Class MyApplication

        Private Sub MyApplication_NetworkAvailabilityChanged(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.Devices.NetworkAvailableEventArgs) Handles Me.NetworkAvailabilityChanged
            AddLog("Application", "Changement rseau : Accessible {0}", e.IsNetworkAvailable, EPrio.Information)
            MdlFriend.NetworkAvailable = e.IsNetworkAvailable
        End Sub

        Private Sub MyApplication_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
            CloseLog(True)
        End Sub

        Private Sub MyApplication_Startup(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.ApplicationServices.StartupEventArgs) Handles Me.Startup
#If DEBUG Then
            CreateLog("NHPopup", "1.03", "Communication sur le rseau DEBUG")
#Else
            CreateLog("NHPopup", "1.03", "Communication sur le rseau")
#End If
            MdlFriend.NetworkAvailable = My.Computer.Network.IsAvailable
            AddLog("Application", "NetworkAvailable : {0}", MdlFriend.NetworkAvailable, EPrio.Information)
            AddHandler My.Settings.SettingChanging, New Configuration.SettingChangingEventHandler(AddressOf MdlFriend.Setting_SettingChanging)
            AddHandler My.Settings.SettingsLoaded, New Configuration.SettingsLoadedEventHandler(AddressOf MdlFriend.Setting_SettingsLoaded)
        End Sub

#If Not Debug Then
        Private Sub MyApplication_UnhandledException(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.ApplicationServices.UnhandledExceptionEventArgs) Handles Me.UnhandledException
            AddLog("Application", "Exception non gre : {0}", e.Exception, EPrio.Erreur)
            If Not (TypeOf e.Exception Is ObjectDisposedException) AndAlso MessageBox.Show("Exception non gre dans l'application, voulez-vous arrter le programme ?" + vbCrLf + ExStr(e.Exception) + vbCrLf + "Si le problme persiste, envoyez la capture d'cran ou le fichier journal  l'auteur (nhprog@laposte.net Fr/En)", "NHPopup", MessageBoxButtons.YesNo, MessageBoxIcon.Error, MessageBoxDefaultButton.Button2) = DialogResult.Yes Then e.ExitApplication = True
        End Sub
#End If

#Region "Liste des messages pour les exceptions"

        Private Function ExStr(ByVal pEx As System.Configuration.ConfigurationErrorsException) As String
            Dim lStr As String = String.Format("Le fichier de configuration ""{0}""({1}) a eu erreur de type : {2}.", pEx.Filename, pEx.Line, pEx.BareMessage)

            For Each lEx As Object In pEx.Errors
                lStr += vbCrLf + lEx.ToString
            Next

            Return lStr
        End Function

        Private Function ExStr(ByVal pEx As Exception) As String
            Dim lStr As String = ""
            If TypeOf pEx Is Configuration.ConfigurationErrorsException Then
                lStr = ExStr(DirectCast(pEx, Configuration.ConfigurationErrorsException))
            Else
                lStr = pEx.ToString
            End If
            Return lStr
        End Function
#End Region


        Private Sub MyApplication_StartupNextInstance(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.ApplicationServices.StartupNextInstanceEventArgs) Handles Me.StartupNextInstance
            AddLog("Application", "Dmarrage d'une nouvelle instance", EPrio.Information)
            My.Forms.FrmPrinc.WindowState = FormWindowState.Normal
            My.Forms.FrmPrinc.Show()
        End Sub
    End Class

End Namespace

