
Friend Class CtlSons


    Private mSndType As ESound = ESound.Aucun


    Public Property SndType() As ESound
        Get
            Return mSndType
        End Get
        Set(ByVal value As ESound)
            If value = mSndType Then Exit Property
            mSndType = value
            Dim lStr As String = ""
            Dim lFile As String = ""
            Try
                Select Case mSndType
                    Case ESound.Ack
                        lStr = "Acquittement"
                        lFile = My.Settings.SoundAck
                    Case ESound.AddClient
                        lStr = "Ajout d'un client"
                        lFile = My.Settings.SoundAddClnt
                    Case ESound.Connect
                        lStr = "Connexion"
                        lFile = My.Settings.SoundReconnect
                    Case ESound.Deconnect
                        lStr = "Dconnexion"
                        lFile = My.Settings.SoundDeconnect
                    Case ESound.Message
                        lStr = "Message"
                        lFile = My.Settings.SoundMsg
                    Case ESound.RmvClient
                        lStr = "Retrait d'un client"
                        lFile = My.Settings.SoundRmvClnt
                End Select
                GP.Text = String.Format("Son pour l'evenement {0}", lStr)
                Select Case lFile.Trim
                    Case ""
                        OptDef.Checked = True
                    Case Else
                        OptPerso.Checked = True
                        TxtFile.Text = lFile
                End Select
            Catch ex As Exception
                AddLog("CtlSons.Prop", "Exception : {0}", ex, EPrio.Avertissement)
            End Try
        End Set
    End Property


    Public Sub DefParams()
        Dim lFile As String = ""

        If IO.File.Exists(TxtFile.Text) And OptPerso.Checked Then
            lFile = TxtFile.Text
        Else
            lFile = ""
        End If

        Select Case mSndType
            Case ESound.Ack
                My.Settings.SoundAck = lFile
            Case ESound.AddClient
                My.Settings.SoundAddClnt = lFile
            Case ESound.Connect
                My.Settings.SoundReconnect = lFile
            Case ESound.Deconnect
                My.Settings.SoundDeconnect = lFile
            Case ESound.Message
                My.Settings.SoundMsg = lFile
            Case ESound.RmvClient
                My.Settings.SoundRmvClnt = lFile
        End Select
    End Sub

    Private Sub CmdPlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdPlay.Click
        Dim lMedia As Media.SoundPlayer = Nothing
        If OptDef.Checked Then
            Select Case mSndType
                Case ESound.Ack
                    lMedia = New Media.SoundPlayer(My.Resources.SoundAck)
                Case ESound.AddClient
                    lMedia = New Media.SoundPlayer(My.Resources.SoundAddClnt)
                Case ESound.Connect
                    lMedia = New Media.SoundPlayer(My.Resources.SoundConnect)
                Case ESound.Deconnect
                    lMedia = New Media.SoundPlayer(My.Resources.SoundDeconnect)
                Case ESound.Message
                    lMedia = New Media.SoundPlayer(My.Resources.SoundMessage)
                Case ESound.RmvClient
                    lMedia = New Media.SoundPlayer(My.Resources.SoundRmvClnt)
            End Select
        ElseIf OptPerso.Checked Then
            Try
                lMedia = New Media.SoundPlayer(TxtFile.Text)
            Catch ex As Exception
                MessageBox.Show("Erreur lors de la lecture du fichier : " + ex.Message, "Son", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                AddLog("CtlSons.CmsPlay", "Exception lors de la lecture du fichier ""{0}"" : {1}", TxtFile.Text, ex, EPrio.Avertissement)
            End Try
        End If

        If lMedia Is Nothing Then Exit Sub

        lMedia.Play()

        lMedia.Dispose()
    End Sub

    Private Sub CmdBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdBrowse.Click
        If TxtFile.Text.Length <> 0 Then DiagOpen.FileName = TxtFile.Text
        If DiagOpen.ShowDialog(Me) = DialogResult.Cancel Then Exit Sub
        TxtFile.Text = DiagOpen.FileName
    End Sub
End Class
