Friend Class FrmOptions

    Private Sub FrmOptions_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Pseudo
        TxtPseudo.Text = ClsUdp.Pseudo
        ChkShowIP.Checked = My.Settings.ShowClientIP
        'Refraichissement
        UDInterval.Value = My.Settings.IntervalRefreshList
        UDDel.Value = My.Settings.NbRefreshBeforeDel
        'Popups
        ChkPopAck.Checked = (My.Settings.Popups And MdlFriend.EPopups.Ack) > 0
        ChkPopMsg.Checked = (My.Settings.Popups And MdlFriend.EPopups.Message) > 0
        ChkPopNew.Checked = (My.Settings.Popups And MdlFriend.EPopups.AddClient) > 0
        ChkPopRmv.Checked = (My.Settings.Popups And MdlFriend.EPopups.RmvClient) > 0
        TBPopOpacity.Value = My.Settings.Opacity
        UDPopDelay.Value = My.Settings.PopupTimeOut
        'IP
        Dim lIP As String() = My.Settings.IPListen.Split("."c)
        If lIP.Length <> 4 Then
            UDIP1.Value = 255
            UDIP2.Value = 255
            UDIP3.Value = 255
            UDIP4.Value = 255
        Else
            UDIP1.Value = CInt(lIP(0))
            UDIP2.Value = CInt(lIP(1))
            UDIP3.Value = CInt(lIP(2))
            UDIP4.Value = CInt(lIP(3))
        End If
        UDIPPort.Value = My.Settings.PortListen
        UDIPTTL.Value = My.Settings.IPTTL
        'Son
        ChkSndConnect.Checked = (My.Settings.Sons And MdlFriend.ESound.Connect) <> 0
        ChkSndDeconnect.Checked = (My.Settings.Sons And MdlFriend.ESound.Deconnect) <> 0
        ChkSndMsg.Checked = (My.Settings.Sons And MdlFriend.ESound.Message) <> 0
        ChkSndAck.Checked = (My.Settings.Sons And MdlFriend.ESound.Ack) <> 0
        ChkSndAddClnt.Checked = (My.Settings.Sons And MdlFriend.ESound.AddClient) <> 0
        ChkSndRmvClnt.Checked = (My.Settings.Sons And MdlFriend.ESound.RmvClient) <> 0
        'Autre
        ChkLog.Checked = My.Settings.ShowLog
    End Sub

    Private Sub TBPopOpacity_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles TBPopOpacity.MouseHover
        Me.Opacity = TBPopOpacity.Value / 100
    End Sub

    Private Sub TBPopOpacity_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TBPopOpacity.MouseLeave
        Me.Opacity = 1
    End Sub

    Private Sub TBPopOpacity_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TBPopOpacity.Scroll
        Me.Opacity = TBPopOpacity.Value / 100
    End Sub

    Private Sub Values_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TxtPseudo.TextChanged, UDIP1.ValueChanged, UDIP2.ValueChanged, UDIP3.ValueChanged, UDIP4.ValueChanged
        Control()
    End Sub


    Private Sub CmdOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdOK.Click
        'Pseudo
        ClsUdp.Pseudo = TxtPseudo.Text
        My.Settings.ShowClientIP = ChkShowIP.Checked
        'Refraichissement
        My.Settings.IntervalRefreshList = CInt(UDInterval.Value)
        My.Settings.NbRefreshBeforeDel = CInt(UDDel.Value)
        'Popups
        Dim lInt As Integer = 0
        If ChkPopAck.Checked Then lInt += MdlFriend.EPopups.Ack
        If ChkPopMsg.Checked Then lInt += MdlFriend.EPopups.Message
        If ChkPopNew.Checked Then lInt += MdlFriend.EPopups.AddClient
        If ChkPopRmv.Checked Then lInt += MdlFriend.EPopups.RmvClient
        My.Settings.Popups = lInt
        My.Settings.Opacity = CInt(TBPopOpacity.Value)
        My.Settings.PopupTimeOut = CInt(UDPopDelay.Value)
        'IP
        Dim lStr As String = String.Join("."c, New String() {CStr(UDIP1.Value), CStr(UDIP2.Value), CStr(UDIP3.Value), CStr(UDIP4.Value)})
        Dim lBoo As Boolean = My.Settings.IPListen <> lStr Or My.Settings.PortListen <> CUShort(UDIPPort.Value) Or My.Settings.IPTTL <> CInt(UDIPTTL.Value)

        My.Settings.IPListen = lStr
        My.Settings.PortListen = CUShort(UDIPPort.Value)
        My.Settings.IPTTL = CInt(UDIPTTL.Value)

        If lBoo Then ClsUdp.RestartNetwork()

        'Son
        lInt = 0
        lInt += IIF(Of Integer)(ChkSndConnect.Checked, MdlFriend.ESound.Connect, 0)
        lInt += IIF(Of Integer)(ChkSndDeconnect.Checked, MdlFriend.ESound.Deconnect, 0)
        lInt += IIF(Of Integer)(ChkSndMsg.Checked, MdlFriend.ESound.Message, 0)
        lInt += IIF(Of Integer)(ChkSndAck.Checked, MdlFriend.ESound.Ack, 0)
        lInt += IIF(Of Integer)(ChkSndAddClnt.Checked, MdlFriend.ESound.AddClient, 0)
        lInt += IIF(Of Integer)(ChkSndRmvClnt.Checked, MdlFriend.ESound.RmvClient, 0)
        My.Settings.Sons = lInt

        'Autre
        My.Settings.ShowLog = ChkLog.Checked

        DialogResult = Windows.Forms.DialogResult.OK
        Close()
    End Sub


    Private Sub Control()
        Dim lGood As Boolean = True
        'pseudo
        lGood = lGood And TxtPseudo.Text.Length > 0
        'IP
        If UDIP1.Value = 255 Then
            lGood = lGood And UDIP2.Value = 255 And UDIP3.Value = 255 And UDIP4.Value = 255
        ElseIf UDIP1.Value >= 224 And UDIP1.Value <= 239 Then
            'Tout est valable
        Else
            lGood = False
        End If
        CmdOK.Enabled = lGood
    End Sub

    Private Sub CmdSound_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdSound.Click
        Dim lFrm As New FrmSound
        lFrm.ShowDialog(Me)
        lFrm.Dispose()
    End Sub
End Class