Friend Class FrmPopup


    Private mLst As New List(Of ClsUdp.ClsDistant)

    'Code rcupr sur la source N32282 du site VBFrance
    'Celui-ci sert  empcher la form de ragir  la souris
    Protected Overrides ReadOnly Property CreateParams() As Windows.Forms.CreateParams
        Get
            Dim cp As CreateParams = MyBase.CreateParams
            cp.ExStyle = cp.ExStyle Or &H80020
            Return cp
        End Get
    End Property


    Private Sub FrmPopup_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Opacity = My.Settings.Opacity / 100
        TopMost = True
        TSize.Enabled = True

        'Link des events
        AddHandler My.Settings.SettingChanging, New Configuration.SettingChangingEventHandler(AddressOf Setting_SettingChanging)
        AddHandler ClsUdp.Ack, New ClsUdp.EvtAck(AddressOf Udp_Ack)
        AddHandler ClsUdp.ChangeDistant, New ClsUdp.EvtChangeDistant(AddressOf Udp_ChangeDistant)
        AddHandler ClsUdp.MessageReceive, New ClsUdp.EvtMessageReceive(AddressOf Udp_MessageReceive)
    End Sub

    Private Sub FrmPopup_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Dim lRect As Rectangle = My.Computer.Screen.WorkingArea
        Me.Top = lRect.Top + lRect.Height - Me.Height
        Me.Left = lRect.Left + lRect.Width - Me.Width
    End Sub

    Private Sub Ctls_Disposed(ByVal sender As Object, ByVal e As System.EventArgs)
        TSize.Enabled = True
        TSize_Tick(TSize, Nothing)
    End Sub

    Private Sub TSize_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSize.Tick
        If IsDisposed Then Exit Sub
        Dim lHeigth As Integer = 0
        For Each lCtl As Control In Controls
            If lHeigth < lCtl.Top + lCtl.Height Then lHeigth = lCtl.Top + lCtl.Height
            If lHeigth < lCtl.Height Then lHeigth = lCtl.Height
        Next
        If lHeigth = Me.ClientSize.Height Then
            Show()
            Visible = True
            TSize.Enabled = False
            Exit Sub
        End If
        ClientSize = New Size(200, lHeigth)

        If Me.Opacity <> My.Settings.Opacity / 100 Then
            Me.Opacity = My.Settings.Opacity / 100
        End If
    End Sub

    Private Sub Setting_SettingChanging(ByVal sender As Object, ByVal e As System.Configuration.SettingChangingEventArgs)
        If e.SettingName = "Opacity" Then
            Me.Opacity = CSng(e.NewValue) / 100
        End If
    End Sub
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <param name="pSender">Emmeteur de l'event</param>
    ''' <param name="pMessage">Message reu</param>
    ''' <remarks></remarks>
    Private Sub Udp_MessageReceive(ByVal pSender As ClsUdp, ByVal pMessage As ClsUdp.ClsMessage)
        If Me.InvokeRequired Then
            Me.Invoke(New ClsUdp.EvtMessageReceive(AddressOf Udp_MessageReceive), New Object() {pSender, pMessage})
            Exit Sub
        End If
        If (My.Settings.Popups And MdlFriend.EPopups.Message) <> 0 Then
            Dim lMsg As New CtlPopMsg
            lMsg.Init(pMessage)
            Add(lMsg)
        End If
    End Sub
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <param name="pDistant">Tableau des clients distant</param>
    ''' <remarks></remarks>
    Private Sub Udp_ChangeDistant(ByVal pDistant As Collections.ObjectModel.ReadOnlyCollection(Of ClsUdp.ClsDistant))
        If Me.InvokeRequired Then
            Me.Invoke(New ClsUdp.EvtChangeDistant(AddressOf Udp_ChangeDistant), New Object() {pDistant})
            Exit Sub
        End If

        Dim lLstNew As New List(Of ClsUdp.ClsDistant)
        Dim lLstAnc As New List(Of ClsUdp.ClsDistant)
        lLstNew.AddRange(pDistant)
        lLstAnc.AddRange(mLst)

        mLst.Clear()
        mLst.AddRange(pDistant)

        For i As Integer = lLstNew.Count - 1 To 0 Step -1
            If lLstAnc.Contains(lLstNew(i)) Then
                lLstAnc.Remove(lLstNew(i))
                lLstNew.RemoveAt(i)
            End If
        Next


        For Each lDist As ClsUdp.ClsDistant In lLstNew
            If (My.Settings.Popups And MdlFriend.EPopups.AddClient) <> 0 Then
                Dim lCtl As New CtlPopLbl
                lCtl.Init(lDist, CtlPopLbl.EType.Add)
                Add(lCtl)
            End If
        Next

        For Each lDist As ClsUdp.ClsDistant In lLstAnc
            If (My.Settings.Popups And MdlFriend.EPopups.RmvClient) <> 0 Then
                Dim lCtl As New CtlPopLbl
                lCtl.Init(lDist, CtlPopLbl.EType.Rmv)
                Add(lCtl)
            End If
        Next
    End Sub
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <param name="pSender">Emmeteur de l'event</param>
    ''' <param name="pDistant">Client distant ayant gnr l'ack</param>
    ''' <remarks></remarks>
    Private Sub Udp_Ack(ByVal pSender As ClsUdp, ByVal pDistant As ClsUdp.ClsDistant)
        If Me.InvokeRequired Then
            Me.Invoke(New ClsUdp.EvtAck(AddressOf Udp_Ack), New Object() {pSender, pDistant})
            Exit Sub
        End If
        If (My.Settings.Popups And MdlFriend.EPopups.Ack) <> 0 Then
            Dim lCtl As New CtlPopLbl
            lCtl.Init(pDistant, CtlPopLbl.EType.Ack)
            Add(lCtl)
        End If
    End Sub

    Private Sub Add(ByVal pCtl As CtlPopBase)
        AddHandler pCtl.Disposed, New EventHandler(AddressOf Ctls_Disposed)
        AddHandler pCtl.Resize, New EventHandler(AddressOf Ctls_Disposed)
        Me.Controls.Add(pCtl)
        Application.DoEvents()
        pCtl.Dock = DockStyle.Top
    End Sub
End Class