Friend Class FrmPrinc

    ''' <summary>
    ''' Mmorise la liste des icones
    ''' </summary>
    ''' <remarks></remarks>
    Private mLstIcons As New Dictionary(Of String, Icon)
    ''' <summary>
    ''' Mmorise le message actuellement affich
    ''' </summary>
    ''' <remarks></remarks>
    Private mActMsg As ClsUdp.ClsMessage = Nothing
    ''' <summary>
    ''' Permet de signaler si l'application peut tre ferme
    ''' </summary>
    ''' <remarks></remarks>
    Private mWantClose As Boolean = False

    Private Sub FrmPrinc_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        TxtActPseudo.Text = ClsUdp.Pseudo
        GPLog.Visible = My.Settings.ShowLog

        'Icones connect
        mLstIcons.Add("00", Drawing.Icon.FromHandle(My.Resources.Task0.GetHicon))
        mLstIcons.Add("01", Drawing.Icon.FromHandle(My.Resources.Task1.GetHicon))
        mLstIcons.Add("02", Drawing.Icon.FromHandle(My.Resources.Task2.GetHicon))
        mLstIcons.Add("03", Drawing.Icon.FromHandle(My.Resources.Task3.GetHicon))
        mLstIcons.Add("04", Drawing.Icon.FromHandle(My.Resources.Task4.GetHicon))
        mLstIcons.Add("05", Drawing.Icon.FromHandle(My.Resources.Task5.GetHicon))
        mLstIcons.Add("06", Drawing.Icon.FromHandle(My.Resources.Task6.GetHicon))
        mLstIcons.Add("07", Drawing.Icon.FromHandle(My.Resources.Task7.GetHicon))
        mLstIcons.Add("08", Drawing.Icon.FromHandle(My.Resources.Task8.GetHicon))
        mLstIcons.Add("09", Drawing.Icon.FromHandle(My.Resources.Task9.GetHicon))
        mLstIcons.Add("10", Drawing.Icon.FromHandle(My.Resources.Task10.GetHicon))
        mLstIcons.Add("11", Drawing.Icon.FromHandle(My.Resources.Task11.GetHicon))
        mLstIcons.Add("Msg", Drawing.Icon.FromHandle(My.Resources.TaskReceive.GetHicon))
        'Icones en cas de problmes rseaux
        mLstIcons.Add("00Not", Drawing.Icon.FromHandle(My.Resources.Task0Not.GetHicon))
        mLstIcons.Add("01Not", Drawing.Icon.FromHandle(My.Resources.Task1Not.GetHicon))
        mLstIcons.Add("02Not", Drawing.Icon.FromHandle(My.Resources.Task2Not.GetHicon))
        mLstIcons.Add("03Not", Drawing.Icon.FromHandle(My.Resources.Task3Not.GetHicon))
        mLstIcons.Add("04Not", Drawing.Icon.FromHandle(My.Resources.Task4Not.GetHicon))
        mLstIcons.Add("05Not", Drawing.Icon.FromHandle(My.Resources.Task5Not.GetHicon))
        mLstIcons.Add("06Not", Drawing.Icon.FromHandle(My.Resources.Task6Not.GetHicon))
        mLstIcons.Add("07Not", Drawing.Icon.FromHandle(My.Resources.Task7Not.GetHicon))
        mLstIcons.Add("08Not", Drawing.Icon.FromHandle(My.Resources.Task8Not.GetHicon))
        mLstIcons.Add("09Not", Drawing.Icon.FromHandle(My.Resources.Task9Not.GetHicon))
        mLstIcons.Add("10Not", Drawing.Icon.FromHandle(My.Resources.Task10Not.GetHicon))
        mLstIcons.Add("11Not", Drawing.Icon.FromHandle(My.Resources.Task11Not.GetHicon))
        mLstIcons.Add("MsgNot", Drawing.Icon.FromHandle(My.Resources.TaskReceiveNot.GetHicon))

        'Evenements UDP
        AddHandler ClsUdp.Ack, New ClsUdp.EvtAck(AddressOf Udp_Ack)
        AddHandler ClsUdp.ChangeDistant, New ClsUdp.EvtChangeDistant(AddressOf Udp_ChangeDistant)
        AddHandler ClsUdp.ChangePseudo, New ClsUdp.EvtChangePseudo(AddressOf Udp_ChangePseudo)
        AddHandler ClsUdp.MessageReceive, New ClsUdp.EvtMessageReceive(AddressOf Udp_MessageReceive)
        AddHandler My.Settings.SettingChanging, New Configuration.SettingChangingEventHandler(AddressOf Setting_SettingChanging)
        AddHandler MdlFriend.NetworkAvailabilityChanged, New MdlFriend.EvtNetworkAvailabilityChanged(AddressOf RefreshIcon)

        'RefreshIcon
        RefreshIcon()

        My.Forms.FrmPopup.Show()

        PlaySound(IIF(MdlFriend.NetworkAvailable, ESound.Connect, ESound.Deconnect))
    End Sub

    Private Sub FrmPrinc_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If mWantClose = False And (e.CloseReason = CloseReason.ApplicationExitCall Or e.CloseReason = CloseReason.FormOwnerClosing Or e.CloseReason = CloseReason.None Or e.CloseReason = CloseReason.UserClosing) Then
            e.Cancel = True
            CtxMnuTrayShow_Click(Nothing, Nothing)
        End If
    End Sub

    Private Sub FrmPrinc_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        ClsBaseThread.StopAllThreads()
    End Sub

    Private Sub RefreshIcon()
        If Me.InvokeRequired Then
            Me.Invoke(New MdlFriend.EvtNetworkAvailabilityChanged(AddressOf RefreshIcon))
            Exit Sub
        End If

        Dim lIcone As Icon = Nothing
        Dim lStr As String = Microsoft.VisualBasic.Right("0" + CStr(ClsUdp.Distants.Count), 2)
        If ClsUdp.Messages.Count > 0 Then lStr = "Msg"
        If ClsUdp.IsConnected = False Then lStr += "Not"
        lIcone = mLstIcons(lStr)
        Me.Icon = lIcone

        NI.Icon = lIcone
        NI.Text = String.Format("{0}, {1} message(s) et {2} clients", IIF(ClsUdp.IsConnected, "Connect", "Dconnect"), ClsUdp.Messages.Count, ClsUdp.Distants.Count)

        TRefresh.Enabled = Not MdlFriend.NetworkAvailable
    End Sub

    Private Sub RefreshMsg(Optional ByVal pMessage As ClsUdp.ClsMessage = Nothing)
        If pMessage IsNot Nothing Then
            If mActMsg Is Nothing OrElse ClsUdp.Messages.IndexOf(mActMsg) = ClsUdp.Messages.Count - 2 Then
                mActMsg = pMessage
            End If
        End If

        If mActMsg Is Nothing And ClsUdp.Messages.Count > 0 Then
            mActMsg = ClsUdp.Messages(ClsUdp.Messages.Count - 1)
        End If

        If mActMsg IsNot Nothing And ClsUdp.Messages.Count = 0 Then
            mActMsg = Nothing
        End If
        If mActMsg IsNot Nothing And ClsUdp.Messages.Contains(mActMsg) = False Then
            mActMsg = Nothing
            RefreshMsg()
            Exit Sub
        End If
        If mActMsg IsNot Nothing Then
            LblMsg.Text = String.Format(CStr(LblMsg.Tag), mActMsg.Heure.ToString("T"), mActMsg.Distant)
            TxtMessage.Text = mActMsg.Message

            CmdMsgDel.Enabled = True
            CmdMsgNext.Enabled = ClsUdp.Messages.IndexOf(mActMsg) < ClsUdp.Messages.Count - 1
            CmdMsgPrevious.Enabled = ClsUdp.Messages.IndexOf(mActMsg) > 0
        Else
            CmdMsgDel.Enabled = False
            CmdMsgNext.Enabled = False
            CmdMsgPrevious.Enabled = False
            LblMsg.Text = "Pas de messages"
            TxtMessage.Text = ""
        End If

        If mActMsg IsNot Nothing Then
            GPMsg.Text = String.Format(CStr(GPMsg.Tag), ClsUdp.Messages.IndexOf(mActMsg) + 1, ClsUdp.Messages.Count)
        Else
            GPMsg.Text = String.Format(CStr(GPMsg.Tag), 0, 0)
        End If

        RefreshIcon()
    End Sub

#Region "Evt App->App"
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <param name="pSender">Emmeteur de l'event</param>
    ''' <param name="pMessage">Message reu</param>
    ''' <remarks></remarks>
    Private Sub Udp_MessageReceive(ByVal pSender As ClsUdp, ByVal pMessage As ClsUdp.ClsMessage)
        If Me.InvokeRequired Then
            Me.Invoke(New ClsUdp.EvtMessageReceive(AddressOf Udp_MessageReceive), New Object() {pSender, pMessage})
            Exit Sub
        End If

        RefreshMsg(pMessage)

        RefreshIcon()
    End Sub
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <param name="pDistant">Tableau des clients distant</param>
    ''' <remarks></remarks>
    Private Sub Udp_ChangeDistant(ByVal pDistant As Collections.ObjectModel.ReadOnlyCollection(Of ClsUdp.ClsDistant))
        If Me.InvokeRequired Then
            Me.Invoke(New ClsUdp.EvtChangeDistant(AddressOf Udp_ChangeDistant), New Object() {pDistant})
            Exit Sub
        End If
        LstClient.Items.Clear()
        Dim lLst As New List(Of ClsUdp.ClsDistant)
        lLst.AddRange(pDistant)
        LstClient.Items.AddRange(lLst.ToArray)
        RefreshIcon()
    End Sub
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <param name="pSender">Emmeteur de l'event</param>
    ''' <param name="pDistant">Client distant ayant gnr l'ack</param>
    ''' <remarks></remarks>
    Private Sub Udp_Ack(ByVal pSender As ClsUdp, ByVal pDistant As ClsUdp.ClsDistant)
        If (My.Settings.Popups And MdlFriend.EPopups.Ack) > 0 Then Exit Sub
        If Me.InvokeRequired Then
            Me.Invoke(New ClsUdp.EvtAck(AddressOf Udp_Ack), New Object() {pSender, pDistant})
            Exit Sub
        End If
        My.Forms.FrmAck.LstAck.Items.Add(pDistant)
        My.Forms.FrmAck.Show(Me)
    End Sub
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <param name="pNewPseudo">Nouveau pseudo</param>
    ''' <param name="pAncPseudo">Ancien pseudo</param>
    ''' <remarks></remarks>
    Private Sub Udp_ChangePseudo(ByVal pNewPseudo As String, ByVal pAncPseudo As String)
        If Me.InvokeRequired Then
            Me.Invoke(New ClsUdp.EvtChangePseudo(AddressOf Udp_ChangePseudo), New Object() {pNewPseudo, pAncPseudo})
            Exit Sub
        End If
        TxtActPseudo.Text = pNewPseudo
        RefreshIcon()
    End Sub

    Private Sub Setting_SettingChanging(ByVal sender As Object, ByVal e As System.Configuration.SettingChangingEventArgs)
        If e.SettingName = "ShowLog" Then
            GPLog.Visible = CBool(e.NewValue)
        End If
    End Sub
#End Region

    Private Sub CmdChangePseudo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdChangePseudo.Click
        Dim lStr As String = InputBox("Entrez le nouveau pseudonyme.", "Changement de pseudo", ClsUdp.Pseudo)
        If lStr.Length > 0 Then ClsUdp.Pseudo = lStr
    End Sub

    Private Sub CmdOption_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdOption.Click
        Dim lFrm As New FrmOptions
        lFrm.ShowDialog(Me)
        lFrm.Dispose()
    End Sub

    Private Sub CmdMsgReply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdMsgReply.Click
        Dim lFrm As New FrmMessage
        If mActMsg IsNot Nothing Then lFrm.TxtPseudo.Text = mActMsg.Distant.Pseudo
        lFrm.ShowDialog(Me)
        lFrm.Dispose()
    End Sub

    Private Sub CmdMsgPrevious_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdMsgPrevious.Click
        mActMsg = ClsUdp.Messages(Max(ClsUdp.Messages.IndexOf(mActMsg) - 1, 0))
        RefreshMsg()
    End Sub

    Private Sub CmdMsgDel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdMsgDel.Click
        If ClsUdp.Messages.Count = 1 Then
            ClsUdp.Messages.Clear()
            mActMsg = Nothing
        Else
            Dim lInt As Integer = ClsUdp.Messages.IndexOf(mActMsg)
            ClsUdp.Messages.RemoveAt(lInt)
            mActMsg = ClsUdp.Messages(Min(lInt, ClsUdp.Messages.Count - 1))
        End If
        RefreshMsg()
    End Sub

    Private Sub CmdMsgNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdMsgNext.Click
        mActMsg = ClsUdp.Messages(Min(ClsUdp.Messages.IndexOf(mActMsg) + 1, ClsUdp.Messages.Count - 1))
        RefreshMsg()
    End Sub

    Private Sub TRefresh_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TRefresh.Tick
        ClsUdp.RefreshState()
    End Sub

    Private Sub FrmPrinc_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Me.WindowState = FormWindowState.Minimized Then
            Me.Hide()
        End If
    End Sub

    Private Sub CtxMnuTrayShow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CtxMnuTrayShow.Click
        If Me.WindowState = FormWindowState.Minimized Then
            Me.Show()
            Me.WindowState = FormWindowState.Normal
            Application.DoEvents()
            Me.Select()
        Else
            Me.WindowState = FormWindowState.Minimized
        End If

    End Sub

    Private Sub CtxMnuTrayClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CtxMnuTrayClose.Click
        If MessageBox.Show("tes-vous sr de vouloir quitter NHPopup ?", "NHPopup", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
            mWantClose = True
            Me.Close()
        End If
    End Sub

    Private Sub NI_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles NI.DoubleClick
        CtxMnuTrayShow_Click(Nothing, Nothing)
    End Sub
End Class
