Module MdlSound

    ''' <summary>
    ''' Mmorise la liste des sons
    ''' </summary>
    ''' <remarks></remarks>
    Private mLstSnd As New Dictionary(Of ESound, Media.SoundPlayer)
    ''' <summary>
    ''' Mmorise la liste des clients connects (pour Add/Rmv
    ''' </summary>
    ''' <remarks></remarks>
    Private mLst As New List(Of ClsUdp.ClsDistant)
    ''' <summary>
    ''' Mmorise les sons jouables pour plus de rapidit
    ''' </summary>
    ''' <remarks></remarks>
    Private mSound As ESound

    ''' <summary>
    ''' Initialise les paramtres locaux
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub Init()
        Dim lSound As Media.SoundPlayer = Nothing
        'Liste des sons
        If My.Settings.SoundAck.Length <> 0 Then
            Try
                lSound = New Media.SoundPlayer(My.Settings.SoundAck)
            Catch ex As Exception
                lSound = New Media.SoundPlayer(My.Resources.SoundAck)
                AddLog("MdlSound.init", "Exception LoadSound {0} ""{1}"" : {2}", ESound.Ack, My.Settings.SoundAck, ex, EPrio.Avertissement)
            End Try
        Else
            lSound = New Media.SoundPlayer(My.Resources.SoundAck)
        End If
        mLstSnd(ESound.Ack) = lSound

        If My.Settings.SoundAddClnt.Length <> 0 Then
            Try
                lSound = New Media.SoundPlayer(My.Settings.SoundAddClnt)
            Catch ex As Exception
                lSound = New Media.SoundPlayer(My.Resources.SoundAddClnt)
                AddLog("MdlSound.init", "Exception LoadSound {0} ""{1}"" : {2}", ESound.AddClient, My.Settings.SoundAddClnt, ex, EPrio.Avertissement)
            End Try
        Else
            lSound = New Media.SoundPlayer(My.Resources.SoundAddClnt)
        End If
        mLstSnd(ESound.AddClient) = lSound

        If My.Settings.SoundRmvClnt.Length <> 0 Then
            Try
                lSound = New Media.SoundPlayer(My.Settings.SoundRmvClnt)
            Catch ex As Exception
                lSound = New Media.SoundPlayer(My.Resources.SoundRmvClnt)
                AddLog("MdlSound.init", "Exception LoadSound {0} ""{1}"" : {2}", ESound.RmvClient, My.Settings.SoundRmvClnt, ex, EPrio.Avertissement)
            End Try
        Else
            lSound = New Media.SoundPlayer(My.Resources.SoundRmvClnt)
        End If
        mLstSnd(ESound.RmvClient) = lSound

        If My.Settings.SoundMsg.Length <> 0 Then
            Try
                lSound = New Media.SoundPlayer(My.Settings.SoundMsg)
            Catch ex As Exception
                lSound = New Media.SoundPlayer(My.Resources.SoundMessage)
                AddLog("MdlSound.init", "Exception LoadSound {0} ""{1}"" : {2}", ESound.Message, My.Settings.SoundMsg, ex, EPrio.Avertissement)
            End Try
        Else
            lSound = New Media.SoundPlayer(My.Resources.SoundMessage)
        End If
        mLstSnd(ESound.Message) = lSound

        If My.Settings.Sounddeconnect.Length <> 0 Then
            Try
                lSound = New Media.SoundPlayer(My.Settings.Sounddeconnect)
            Catch ex As Exception
                lSound = New Media.SoundPlayer(My.Resources.Sounddeconnect)
                AddLog("MdlSound.init", "Exception LoadSound {0} ""{1}"" : {2}", ESound.Deconnect, My.Settings.SoundDeconnect, ex, EPrio.Avertissement)
            End Try
        Else
            lSound = New Media.SoundPlayer(My.Resources.SoundDeconnect)
        End If
        mLstSnd(ESound.Deconnect) = lSound

        If My.Settings.SoundReconnect.Length <> 0 Then
            Try
                lSound = New Media.SoundPlayer(My.Settings.SoundReconnect)
            Catch ex As Exception
                lSound = New Media.SoundPlayer(My.Resources.SoundConnect)
                AddLog("MdlSound.init", "Exception LoadSound {0} ""{1}"" : {2}", ESound.Connect, My.Settings.SoundReconnect, ex, EPrio.Avertissement)
            End Try
        Else
            lSound = New Media.SoundPlayer(My.Resources.SoundConnect)
        End If
        mLstSnd(ESound.Connect) = lSound

        'Link des events
        AddHandler My.Settings.SettingChanging, New Configuration.SettingChangingEventHandler(AddressOf Setting_SettingChanging)
        AddHandler ClsUdp.Ack, New ClsUdp.EvtAck(AddressOf Udp_Ack)
        AddHandler ClsUdp.ChangeDistant, New ClsUdp.EvtChangeDistant(AddressOf Udp_ChangeDistant)
        AddHandler ClsUdp.MessageReceive, New ClsUdp.EvtMessageReceive(AddressOf Udp_MessageReceive)
        AddHandler MdlFriend.NetworkAvailabilityChanged, New MdlFriend.EvtNetworkAvailabilityChanged(AddressOf Application_Network)

        'Sons jouables
        mSound = CType(My.Settings.Sons, ESound)
    End Sub


    ''' <summary>
    ''' Joue un son prenregistr
    ''' </summary>
    ''' <param name="pType">Type du son  jouer</param>
    ''' <remarks></remarks>
    Friend Sub PlaySound(ByVal pType As MdlFriend.ESound)
        If mLstSnd.Count = 0 Then
            Init()
        End If
        Try
            If (mSound And pType) <> 0 Then
                mLstSnd(pType).Play()
            End If
        Catch ex As Exception
            AddLog("Sons", "Le son {0} n'a pas pu tre charg : {1}", pType, ex, EPrio.Haute)
        End Try
    End Sub


    Private Sub Setting_SettingChanging(ByVal sender As Object, ByVal e As System.Configuration.SettingChangingEventArgs)
        Dim lSnd As ESound = ESound.Aucun

        Select Case e.SettingClass
            Case "Sons"
                mSound = CType(e.NewValue, ESound)
            Case "SoundAck"
                lSnd = ESound.Ack
            Case "SoundMsg"
                lSnd = ESound.Message
            Case "SoundAddClnt"
                lSnd = ESound.AddClient
            Case "SoundRmvClnt"
                lSnd = ESound.RmvClient
            Case "SoundDeconnect"
                lSnd = ESound.Deconnect
            Case "SoundReconnect"
                lSnd = ESound.Connect
        End Select

        'Maj du son correspondant
        If lSnd <> ESound.Aucun Then
            mLstSnd(lSnd).Dispose()
            If e.NewValue.ToString.Trim.Length = 0 Then
                mLstSnd(lSnd) = New Media.SoundPlayer(My.Resources.SoundAck)
            Else
                Try
                    mLstSnd(lSnd) = New Media.SoundPlayer(e.NewValue.ToString)
                Catch ex As Exception
                    mLstSnd(lSnd) = New Media.SoundPlayer(My.Resources.SoundAck)
                    AddLog("Chngt sons", "{0} Ex non gre fichier ""{1}"" : {2}", lSnd, e.NewValue, ex, EPrio.Erreur)
                    e.Cancel = True
                End Try
            End If
        End If
    End Sub
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <param name="pSender">Emmeteur de l'event</param>
    ''' <param name="pMessage">Message reu</param>
    ''' <remarks></remarks>
    Private Sub Udp_MessageReceive(ByVal pSender As ClsUdp, ByVal pMessage As ClsUdp.ClsMessage)
        PlaySound(ESound.Message)
    End Sub
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <param name="pDistant">Tableau des clients distant</param>
    ''' <remarks></remarks>
    Private Sub Udp_ChangeDistant(ByVal pDistant As Collections.ObjectModel.ReadOnlyCollection(Of ClsUdp.ClsDistant))
        Dim lLstNew As New List(Of ClsUdp.ClsDistant)
        Dim lLstAnc As New List(Of ClsUdp.ClsDistant)
        lLstNew.AddRange(pDistant)
        lLstAnc.AddRange(mLst)

        mLst.Clear()
        mLst.AddRange(pDistant)

        For i As Integer = lLstNew.Count - 1 To 0 Step -1
            If lLstAnc.Contains(lLstNew(i)) Then
                lLstAnc.Remove(lLstNew(i))
                lLstNew.RemoveAt(i)
            End If
        Next

        For Each lDist As ClsUdp.ClsDistant In lLstNew
            PlaySound(ESound.AddClient)
        Next

        For Each lDist As ClsUdp.ClsDistant In lLstAnc
            PlaySound(ESound.RmvClient)
        Next
    End Sub
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <param name="pSender">Emmeteur de l'event</param>
    ''' <param name="pDistant">Client distant ayant gnr l'ack</param>
    ''' <remarks></remarks>
    Private Sub Udp_Ack(ByVal pSender As ClsUdp, ByVal pDistant As ClsUdp.ClsDistant)
        PlaySound(ESound.Ack)
    End Sub
    ''' <summary>
    ''' Gestionnaire de l'event
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub Application_Network()
        If MdlFriend.NetworkAvailable Then
            PlaySound(ESound.Connect)
        Else
            PlaySound(ESound.Deconnect)
        End If
    End Sub
End Module
